#ifndef _LIB_IOCTRL_H
#define _LIB_IOCTRL_H

typedef enum{
	GPIO_PIN1,
	GPIO_PIN2,
	GPIO_PIN3,
	GPIO_PIN4,
	GPIO_PIN5,
	GPIO_PIN6,
	GPIO_PIN7,
	GPIO_PIN8
}GPIO_INDEX;

typedef enum{
	GPIO_LOW_LEVEL,
	GPIO_HIGH_LEVEL
}GPIO_LEVEL;

typedef enum{
	SET_GPIO_IN,
	SET_GPIO_OUT
}GPIO_INOUT;

typedef enum{
	SET_MINUTE,
	SET_SECOND
}WDT_MODE;

struct __WDT_INFO{
	int nowayout;
	unsigned char mode;
	unsigned char time;
	unsigned char wdtinited;
	unsigned char enable;
};

//init system driver
/*
**libIoCtrlInit
**˵:ʼSDK̬
**hlib ģַָ룬bios_id BIOS IDţBIOS setupпԲ鿴õ
**ֵ: 0 ɹ0ʧ ɹʱHMODULEʵhlib
*/
extern "C" __declspec(dllexport) int libIoCtrlInit(HMODULE *hlib,char* bios_id);

//for gpio 
/*
**setPinInOut
**˵:ùܽŵ
**hlib ģַָ룬index ܽţοGPIO_INDEXöٶ壩state ܽ(οGPIO_INOUTöٶ)
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int setPinInOut(HMODULE *hlib, GPIO_INDEX index, GPIO_INOUT state);

/*
**getPinLevel
**˵:ȡܽŵ״̬
**hlib ģַָ룬index ܽţοGPIO_INDEXöٶ壩curstate Ĺܽ״̬,0Ϊ͵ƽ1Ϊߵƽ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int getPinLevel(HMODULE *hlib, GPIO_INDEX index, unsigned char* curstate);


/*
**setPinLevel
**˵:ùܽŵ״̬
**hlib ģַָ룬index ܽţοGPIO_INDEXöٶ壩curstate ùܽ״̬,0Ϊ͵ƽ1Ϊߵƽ(ΪĴ״̬ʵʵ·״̬ȡⲿ·)
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int setPinLevel(HMODULE *hlib, GPIO_INDEX index, GPIO_LEVEL curstate);

//for watchdog
/*
**cfgWatchdog
**˵:ÿŹ
**hlib ģַָ룬iwdtinfo Ź״̬壬οstruct __WDT_INFOĶ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int cfgWatchdog(HMODULE *hlib, struct __WDT_INFO* wdtinfo);

/*
**enableWatchdog
**˵:ÿŹȡstruct __WDT_INFO nowayoutãnowayoutΪ1ʱ˺Чκʱ򶼻᷵سɹǲ߹رն
**hlib ģַָ룬envalue 1  0 ر 
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int enableWatchdog(HMODULE *hlib, unsigned char envalue);


/*
**feedWatchdog
**˵:ιBIOSѿŹɲcfgWatchdogÿŹֱӵô˺valueŹʱ()ѾcfgWatchdogÿŹcfgWatchdog
**         òΪ׼Ҫ´valueŹʱ(ʱЧ)
**hlib ģַָ룬
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int feedWatchdog(HMODULE *hlib, unsigned char value);

//deinit system driver,exit
/*
**libIoCtrlDeinit
**˵:жSDK̬
**hlib ģַָ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int libIoCtrlDeinit(HMODULE *hlib);

#endif