#ifndef _LIB_IOCTRL_H
#define _LIB_IOCTRL_H

#define   LBP_GROUPA_MASK                 0x01
#define   LBP_GROUPB_MASK                 0x02
#define   LBP_PUBLIC_MASK                 0x04

#define   PBS_SW1_MASK                    0x01
#define   PBS_SW2_MASK                    0x02
#define   PBS_SW3_MASK                    0x04
#define   PBS_SW4_MASK                    0x08

#define   GPIO_DYNAMIC_INOUT               0
#define   GPIO_FIXED_INOUT                 1
#define   GPIO_FIXED_MMIO_ADDR_ACCESS      0xFE
#define   GPIO_FIXED_IOSPACE_ADDR_ACCESS   0xFF

typedef enum{
	GPIO_PIN1,
	GPIO_PIN2,
	GPIO_PIN3,
	GPIO_PIN4,
	GPIO_PIN5,
	GPIO_PIN6,
	GPIO_PIN7,
	GPIO_PIN8,
	GPIO_PIN9,
	GPIO_PIN10,
	GPIO_PIN11,
	GPIO_PIN12,
	GPIO_PIN13,
	GPIO_PIN14,
	GPIO_PIN15,
	GPIO_PIN16
}GPIO_PIN_INDEX;

typedef enum {
	WDT_SECOND_MODE,
	WDT_MINUTE_MODE
}WDT_TIMER_MODE;

typedef enum {
	DERECT_OUPUT,
	DERECT_INPUT
}GPIO_DERECTION_INFO;

typedef enum {
	GPIO_LOW_LEVEL,
	GPIO_HIGH_LEVEL
}GPIO_LEVEL;

typedef enum {
	BYPASS_GROUPA_INDEX,
	BYPASS_GROUPB_INDEX,
	BYPASS_PUBLIC_INDEX
}BYPASS_INDEX;

typedef enum {
	POWER_BUTTON1,
	POWER_BUTTON2,
	POWER_BUTTON3,
	POWER_BUTTON4
}POWERBUTTON_INDEX;


struct __WDT_INFO {
	unsigned char nowayout; //˳־0˳ 1󲻿˳
	unsigned char mode;     //ģʽ߷ģʽ
	unsigned char time;     //ʱֵ
	unsigned char enable;   //ɺŹ
};



//init system driver
/*
**libIoCtrlInit
**˵:ʼSDK̬
**hlib ģַָ룬bios_id BIOS IDţBIOS setupпԲ鿴õ
**ֵ: 0 ɹ0ʧ ɹʱHMODULEʵhlib
*/
extern "C" __declspec(dllexport) int libIoCtrlInit(HMODULE * hlib, char* bios_id);


/*
**libIoCtrlGetVersion
**˵:ȡSDK̬汾
**hlib ģַָ룬version SdK汾
**ֵ: 0 ɹ0ʧ ɹʱdemo sdk İ汾(ַ)
*/
extern "C" __declspec(dllexport) int libIoCtrlGetVersion(HMODULE * hlib, char* version);

//for gpio
/*
**IsGpioSupported
**˵:ѯĿǷ֧GPIO
**
**hlib ģַָ
*       isSupport Ŀ֧gpio״̬,0Ϊ֧֣1ΪĿ֧gpio
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int IsGpioSupported(const HMODULE * hlib, unsigned char* isSupport);

/*
**getGpioDerectionState
**˵:ȡGPIO I/O ״̬״̬
**hlib ģַָ룬*derection I/O ״̬-- 1: Input mode 0: Output mode (bit0Ӧpin1,bit1Ӧpin2...) *currentState I/O (bit0Ӧpin1,bit1Ӧpin2...) 
**      *fixed GPIO̶ģʽ(GPIO_FIXED_INOUT: ̶ģʽ GPIO_DYNAMIC_INOUT̬ģõģʽ)
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int getGpioState(HMODULE * hlib, unsigned int* derection, unsigned int* currentState, unsigned char* fixed);

/*
**getGpioMaxPin
**˵:ȡֵ֧GPIOܽ
**hlib ģַָ룬pinnum Ĺܽ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int getGpioMaxPin(HMODULE * hlib, unsigned char* pinnum);

/*
**setPinInOut
**˵:ùܽŵ
**hlib ģַָ룬index ܽţοGPIO_INDEXöٶ壩state ܽ(οGPIO_INOUTöٶ)
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int setPinInOut(HMODULE * hlib, GPIO_PIN_INDEX index, GPIO_DERECTION_INFO state);

/*
**getPinLevel
**˵:ȡܽŵ״̬
**hlib ģַָ룬index ܽţοGPIO_INDEXöٶ壩curstate Ĺܽ״̬,0Ϊ͵ƽ1Ϊߵƽ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int getPinLevel(HMODULE * hlib, GPIO_PIN_INDEX index, unsigned char* curstate);


/*
**setPinLevel
**˵:ùܽŵ״̬
**hlib ģַָ룬index ܽţοGPIO_INDEXöٶ壩curstate ùܽ״̬,0Ϊ͵ƽ1Ϊߵƽ(ΪĴ״̬ʵʵ·״̬ȡⲿ·)
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int setPinLevel(HMODULE * hlib, GPIO_PIN_INDEX index, GPIO_LEVEL curstate);

//for watchdog
/*
**OpenWatchdog
**˵:ÿŹ
**hlib ģַָ룬wdtinfo Ź״̬壬οstruct __WDT_INFOĶ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int OpenWatchdog(HMODULE * hlib, struct __WDT_INFO* wdtinfo);

/*
**updateWatchdog
**˵:¿Źʱò
**hlib ģַָ룬
**wdtinfo Ź״̬壬οstruct __WDT_INFOĶ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int updateWatchdog(HMODULE * hlib, struct __WDT_INFO* wdtinfo);

/*
**enableWatchdog
**˵:߹رտŹرղȡstruct __WDT_INFO nowayoutãnowayoutΪ1ʱرն
**hlib ģַָ룬enValue 1  0 ر
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int enableWatchdog(HMODULE * hlib, unsigned char enValue);

/*
**KeepWatchdogAlive
**˵:ÿŹʱ(ι)
**         
**hlib ģַָ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int KeepWatchdogAlive(HMODULE * hlib);

/*
**CloseWatchdogTimer
**˵:رտŹʱ(OpenWatchdogĲnowayoutΪ0ֹͣŹʱεã0εãرտŹʱ)
**
**hlib ģַָ룬
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int CloseWatchdog(const HMODULE * hlib);


//Lan Bypass support

/*
**IsLanBypassSupported
**˵:ѯĿǷ֧bypass
**
**hlib ģַָ
*       isSupport Ŀ֧lanbypass״̬,0Ϊ֧֣1ΪĿ֧Lan Bypass
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int IsLanBypassSupported(const HMODULE * hlib, unsigned char* isSupport);

/*
**GetLanBypassState
**˵:ѯBypass֧״̬
**
**hlib ģַָ
*       state lanbypass״̬,bit0ΪGroup A״̬bit1ΪGroup B״̬ λֵΪ0ʾĿǰΪر״̬1Ϊ״̬
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int GetLanBypassState(const HMODULE * hlib, unsigned char* state);

/*
**LanBypassEnable
**˵:߹رLan bypass
**
**hlib ģַָ
*       index lanbypass(οBYPASS_INDEX)
*		Enable  0ر 1
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int LanBypassEnable(const HMODULE * hlib, BYPASS_INDEX index, unsigned char Enable);

//Power Button Switch support

/*
**IsPowerButtonSWSupported
**˵:ѯĿǷ֧Power Button Switch
**
**hlib ģַָ
*       isSupport Ŀ֧lanbypass״̬,0Ϊ֧֣1ΪĿ֧Power Button Switch
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int IsPowerButtonSWSupported(const HMODULE * hlib, unsigned char* isSupport);

/*
**GetPowerButtonSWAccessState
**˵:ѯBypass֧״̬
**
**hlib ģַָ
*       state Power Button Switch״̬,bit0ΪButton1 ״̬bit1ΪButton2״̬ ....
*       mode  Power Button SwitchģʽLevel=0 edge=1 bit0ΪButton1 ģʽbit1ΪButton2ģʽ ...
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int GetPowerButtonSWAccessState(const HMODULE * hlib, unsigned char* state, unsigned char* mode);

/*
**PowerButtonSWEnable
**˵:߹رLan bypass
**
**hlib ģַָ
*       index Button(οPOWERBUTTON_INDEX)
*		Enable  0ر 1 ΪPOWER_BUTTON_EDGEģʽ˲Ӱ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int PowerButtonSWEnable(const HMODULE * hlib, POWERBUTTON_INDEX index, unsigned char Enable);

/*
**SysBeepEnable(const HMODULE * hlib, unsigned short Frequency)
**˵:߹رSystem Buzzer
**
**hlib ģַָ
*		Frequency  0ݲ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int SysBeepEnable(const HMODULE * hlib, unsigned short Frequency);

//deinit system driver,exit
/*
**libIoCtrlDeinit
**˵:жSDK̬
**hlib ģַָ
**ֵ: 0 ɹ0ʧ
*/
extern "C" __declspec(dllexport) int libIoCtrlDeinit(HMODULE * hlib);

#endif